﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO.Ports;  //追加 シリアルポートコンポーネント用


namespace USB_CDC_Str_SendReceive2
{
    public partial class Form1 : Form
    {
        int OK_COM = 0; //COMポート接続完了フラグ
        bool LampCOM = false;   //COM/USB 接続表示
        bool PerformClick = false;  //偽クリック発生   //ピクチャーボックス再描画
        bool RichTextBoxWritable = false;   //リッチテキストボックス書き込み禁止（許可）



        //文字を変換するクラスを宣言
        Encoding encSjis = Encoding.GetEncoding("shift-jis");
        Encoding encUni = Encoding.GetEncoding("unicode");

        delegate void ReceiveDelegate(string str);//デリゲート宣言
        public Form1()
        {
            InitializeComponent();

            SendDataCBox.Items.Clear();
            SendDataCBox.Items.Add("Japan");
            SendDataCBox.Items.Add("America");
            SendDataCBox.Items.Add("U.K.");
            SendDataCBox.Items.Add("France");
            SendDataCBox.Items.Add("How are you ?");
            SendDataCBox.SelectedIndex = 0;

            SendDataBtn.Visible = false;
            SendDataCBox.Visible = false;
            SendDataLabel.Visible = false;

           
        }

        enum WINDOW_MESSAGES : uint
        {
            WM_DEVICECHANGE = 0x0219,
        }

        private enum DBT
        {
            DBT_DEVICEARRIVAL = 0x8000,
            DBT_DEVICEQUERYREMOVE = 0x8001,
            DBT_DEVICEQUERYREMOVEFAILED = 0x8002,
            DBT_DEVICEREMOVEPENDING = 0x8003,
            DBT_DEVICEREMOVECOMPLETE = 0x8004,
        }

    protected override void WndProc(ref Message m)
        {

            switch ((WINDOW_MESSAGES)m.Msg)
            {
                case WINDOW_MESSAGES.WM_DEVICECHANGE:
                    //    pnpEvent(this, EventArgs.Empty);

                    switch ((DBT)m.WParam.ToInt32())
                    {
                        case DBT.DBT_DEVICEARRIVAL:
                            //ドライブが装着された時の処理を書く
                            LampCOM = true;
                            ConnectLabel.Text = "接続完了";
                            PerformClick = true;        //クリックによるリッチテキストクリア動作を無効化
                            ClearBtn.PerformClick();    //イベントを発生させ、Form1_Paint()を実行して描画を行う。
                            PerformClick = false;       //クリックによるリッチテキストクリア動作を有効化
                            RichTextBoxWritable = true; //リッチテキストボックス書き込み許可
                            break;
                        case DBT.DBT_DEVICEREMOVECOMPLETE:
                            //ドライブが取り外されたされた時の処理を書く
                            LampCOM = false;
                            ConnectLabel.Text = "未接続";
                            RichTextBoxWritable = false;    //リッチテキストボックス書き込み禁止
                            break;
                    }

                   

                    break;
            }
            base.WndProc(ref m);
        }


        private void Form1_Paint(object sender, PaintEventArgs e)   //USB接続/未接続のイメージランプ描画
        {
            if(LampCOM == false)
            {
                Graphics g = pictureBox1.CreateGraphics();  //CreateGraphicsメソッドによりGraphicsオブジェクトを取得 
                g.FillEllipse(Brushes.Gray, 10, 0, 50, 50); //灰色塗りつぶし　基点(10,0)　幅×高さ：50×50
            }
            else
            {
                Graphics g = pictureBox1.CreateGraphics();  //CreateGraphicsメソッドによりGraphicsオブジェクトを取得   
                g.FillEllipse(Brushes.Orange, 10, 0, 50, 50);//橙色塗りつぶし　基点(10,0)　幅×高さ：50×50
            }

        

        }

        private void SetText(string str)
        {
            if(RichTextBoxWritable == true) //リッチテキストボックス書き込み許可の場合
            {
                richTextBox1.AppendText(str);   //文字列追加
                richTextBox1.AppendText("\n");  //改行

            }
        }

        private void ComPortConnectTry()    //COMポート接続チェック
        {
       


            try
            {
                serialPort1.DiscardInBuffer();  //受信バッファのデータクリア

                string strSend = "Are you Ready ?";
                if (!strSend.EndsWith("\r")) strSend += "\r";  //改行が無かったら \rを追加する
                Byte[] byteArry = encSjis.GetBytes(strSend); //'送信文字をShift-jisに変換してをByte配列に格納
                serialPort1.Write(byteArry, 0, byteArry.Length); //送信

                string OK_message = "I am Ready\r\n";

                string Response = serialPort1.ReadLine();   //返信データ抜き取り
                OK_COM = OK_message.CompareTo(Response);    //返信データが "I am Ready\r\n"の場合　1 を返す
                if (OK_COM == 1)
                {
                    ConnectLabel.Text = "接続完了";
                    SendDataBtn.Visible = true;
                    SendDataCBox.Visible = true;
                    SendDataLabel.Visible = true;

                    LampCOM = true;
                    ConnectBtn.Enabled = true;

                }
                MessageBox.Show(Response);
                RichTextBoxWritable = true;
                
            }
            catch (Exception ex2)
            {
                OK_COM = 0;
                ConnectLabel.Text = "未接続";
                SendDataBtn.Visible = false;
                SendDataCBox.Visible = false;
                SendDataLabel.Visible = false;

                LampCOM = false;
                ConnectBtn.Enabled = false;
                RichTextBoxWritable = false;    //リッチテキストボックス書き込み禁止


                if (ex2 is TimeoutException)
                {
                    string TimeoutStr = "1. COMポートをかえてみてください \n2. COMポートコネクタの抜けなど断線がないチェックしてください。";
                    MessageBox.Show(ex2.Message + "\n" + TimeoutStr);
                }
                else MessageBox.Show(ex2.Message);
            }


        }




        private void ConnectBtn_Click(object sender, EventArgs e)   //接続ボタン
        {
            if(ConnectBtn.Text == "停止")
            {
                serialPort1.Close();//シリアルポートオープン
                ConnectBtn.Text = "接続";
                SendDataBtn.Visible = false;
                SendDataCBox.Visible = false;
                SendDataLabel.Visible = false;
                ConnectLabel.Text = "未接続";
                LampCOM = false;
                ComCBox.Items.Clear();
                ComCBox.Text = "";

                return;
            }
           

            if (ConnectBtn.Enabled == true) ConnectBtn.Text = "停止";
            else ConnectBtn.Text = "接続";
         


            string[] PortList = SerialPort.GetPortNames();

            try
            {
                ComCBox.Items.Clear();

                //シリアルポート名をコンボボックスにセット
                foreach (string PortName in PortList)
                {
                    ComCBox.Items.Add(PortName);
                }
                if (ComCBox.Items.Count > 0)
                {
                    ComCBox.SelectedIndex = 0;
                }

                serialPort1.PortName = ComCBox.SelectedItem.ToString();

                //   serialPort1.PortName = "COM3";  //COM1 ﾎﾟｰﾄ使用
                //   serialPort1.PortName = "COM4";  //COM1 ﾎﾟｰﾄ使用
                serialPort1.BaudRate = 9600;   //9600bps
                serialPort1.Parity = System.IO.Ports.Parity.None;  //パリティなし
                serialPort1.DataBits = 8;  //データ長　8ビット
                serialPort1.StopBits = System.IO.Ports.StopBits.One;   //ストップビット 1
                serialPort1.ReadTimeout = 500;     //500mse 読み込みタイムアウト時間
                serialPort1.WriteTimeout = 500;    //500msec書き込みタイムアウト時間

                serialPort1.Open();//シリアルポートオープン

            }
            catch (Exception ex)
            {
                DialogResult result = MessageBox.Show
                (ex.Message + "\n" + "COMポートがひらけません");
            }

            ComPortConnectTry();    //COMポート接続チェック

        }

        private void SendDataBtn_Click(object sender, EventArgs e)  //データ送信ボタン
        {
            try
            {
                if (serialPort1.IsOpen == false) serialPort1.Open();//シリアルポートオープン

                serialPort1.DiscardInBuffer();  //受信バッファのデータクリア

                string strSend = SendDataCBox.Text;
                if (!strSend.EndsWith("\r")) strSend += "\r";  //改行が無かったら \rを追加する
                Byte[] byteArry = encSjis.GetBytes(strSend); //'送信文字をShift-jisに変換してをByte配列に格納
                serialPort1.Write(byteArry, 0, byteArry.Length); //送信
            }
            catch (Exception ex)
            {
                DialogResult result = MessageBox.Show
                (ex.Message + "\n" + "COMポートがひらけません");
            }
        }

        private void ClearBtn_Click(object sender, EventArgs e) //クリアボタン
        {
            if(PerformClick == false)richTextBox1.Clear();  //マウスでの実際のクリックが発生した場合のみ　リッチテキストクリア
        }

        private void serialPort1_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {

            byte[] byteRead = new byte[serialPort1.BytesToRead];  //受信文字

            serialPort1.Read(byteRead, 0, serialPort1.BytesToRead);//読み込み
            byte[] byteUni = Encoding.Convert(encSjis, encUni, byteRead);   //shift-jis　からunicodeに変換する
            string strUni = encUni.GetString(byteUni);  //配列を文字列に変換
            ReceiveDelegate receiveDelegate = new ReceiveDelegate(SetText);
            this.Invoke(receiveDelegate, strUni);
        }

        private void ComCBox_TextChanged(object sender, EventArgs e)
        {

            if (serialPort1.IsOpen == true)
            {
                serialPort1.Close();//シリアルポートクローズ

                serialPort1.PortName = ComCBox.SelectedItem.ToString();
                serialPort1.BaudRate = 9600;   //9600bps
                serialPort1.Parity = System.IO.Ports.Parity.None;  //パリティなし
                serialPort1.DataBits = 8;  //データ長　8ビット
                serialPort1.StopBits = System.IO.Ports.StopBits.One;   //ストップビット 1
                serialPort1.ReadTimeout = 500;     //500mse 読み込みタイムアウト時間
                serialPort1.WriteTimeout = 500;    //500msec書き込みタイムアウト時間

                serialPort1.Open();//シリアルポートオープン

                ComPortConnectTry();    //COMポート接続チェック
            }
        }
 
    }
}
